org.apache.xml.dtm.ref

## Class DTMDocumentImpl

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMDocumentImpl

- All Implemented Interfaces:
    DTM, org.xml.sax.ContentHandler, org.xml.sax.ext.LexicalHandler

      public class DTMDocumentImpl
      extends java.lang.Object
      implements DTM, org.xml.sax.ContentHandler, org.xml.sax.ext.LexicalHandler

  This is the implementation of the DTM document interface. It receives requests from an XML content handler similar to that of an XML DOM or SAX parser to store information from the xml document in an array based dtm table structure. This informtion is used later for document navigation, query, and SAX event dispatch functions. The DTM can also be used directly as a document composition model for an application. The requests received are:
  - initiating DTM to set the doc handle
  - resetting DTM for data structure reuse
  - hinting the end of document to adjust the end of data structure pointers
  - createnodes (element, comment, text, attribute, ....)
  - hinting the end of an element to patch parent and siblings
  - setting application provided symbol name stringpool data structures

  State: In progress!!

  %REVIEW% I _think_ the SAX convention is that "no namespace" is expressed as "" rather than as null (which is the DOM's convention). What should DTM expect? What should it do with the other?

  Origin: the implemention is a composite logic based on the DTM of XalanJ1 and DocImpl, DocumentImpl, ElementImpl, TextImpl, etc. of XalanJ2

- - ### Field Summary

    - ### Fields inherited from interface org.apache.xml.dtm.DTM

      `ATTRIBUTE_NODE, CDATA_SECTION_NODE, COMMENT_NODE, DOCUMENT_FRAGMENT_NODE, DOCUMENT_NODE, DOCUMENT_TYPE_NODE, ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, NAMESPACE_NODE, NOTATION_NODE, NTYPES, NULL, PROCESSING_INSTRUCTION_NODE, ROOT_NODE, TEXT_NODE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DTMDocumentImpl(DTMManager mgr, int documentNumber, DTMWSFilter whiteSpaceFilter, XMLStringFactory xstringfactory)` Construct a DTM.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `appendChild(int newChild, boolean clone, boolean cloneDepth)` Append a child to the end of the child list of the current node.
    `void` | `appendTextChild(java.lang.String str)` Append a text node child that will be constructed from a string, to the end of the document.
    `void` | `characters(char[] ch, int start, int length)`
    `void` | `comment(char[] ch, int start, int length)`
    `void` | `dispatchCharactersEvents(int nodeHandle, org.xml.sax.ContentHandler ch, boolean normalize)` Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `void` | `dispatchToEvents(int nodeHandle, org.xml.sax.ContentHandler ch)` Directly create SAX parser events from a subtree.
    `void` | `documentRegistration()` A dummy routine to satisify the abstract interface.
    `void` | `documentRelease()` A dummy routine to satisify the abstract interface.
    `void` | `endCDATA()`
    `void` | `endDocument()`
    `void` | `endDTD()`
    `void` | `endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName)`
    `void` | `endEntity(java.lang.String name)`
    `void` | `endPrefixMapping(java.lang.String prefix)`
    `int` | `getAttributeNode(int nodeHandle, java.lang.String namespaceURI, java.lang.String name)` Retrieves an attribute node by by qualified name and namespace URI.
    `DTMAxisIterator` | `getAxisIterator(int axis)` This is a shortcut to the iterators that implement the supported XPath axes (only namespace::) is not supported.
    `DTMAxisTraverser` | `getAxisTraverser(int axis)` This returns a stateless "traverser", that can navigate over an XPath axis, though not in document order.
    `org.xml.sax.ContentHandler` | `getContentHandler()` getContentHandler returns "our SAX builder" -- the thing that someone else should send SAX events to in order to extend this DTM model.
    `org.xml.sax.ext.DeclHandler` | `getDeclHandler()` Return this DTM's DeclHandler.
    `int` | `getDocument()` Given a node handle, find the owning document node.
    `boolean` | `getDocumentAllDeclarationsProcessed()` Return an indication of whether the processor has read the complete DTD.
    `java.lang.String` | `getDocumentBaseURI()` Return the base URI of the document entity.
    `java.lang.String` | `getDocumentEncoding(int nodeHandle)` Return the name of the character encoding scheme in which the document entity is expressed.
    `int` | `getDocumentRoot()` Returns the root element of the document.
    `int` | `getDocumentRoot(int nodeHandle)` Given a node handle, find the owning document node.
    `java.lang.String` | `getDocumentStandalone(int nodeHandle)` Return an indication of the standalone status of the document, either "yes" or "no".
    `java.lang.String` | `getDocumentSystemIdentifier(int nodeHandle)` Return the system identifier of the document entity.
    `java.lang.String` | `getDocumentTypeDeclarationPublicIdentifier()` Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML].
    `java.lang.String` | `getDocumentTypeDeclarationSystemIdentifier()` A document type declaration information item has the following properties: 1.
    `java.lang.String` | `getDocumentVersion(int documentHandle)` Return a string representing the XML version of the document.
    `org.xml.sax.DTDHandler` | `getDTDHandler()` Return this DTM's DTDHandler.
    `int` | `getElementById(java.lang.String elementId)` Returns the `Element` whose `ID` is given by `elementId`.
    `org.xml.sax.EntityResolver` | `getEntityResolver()` Return this DTM's EntityResolver.
    `org.xml.sax.ErrorHandler` | `getErrorHandler()` Return this DTM's ErrorHandler.
    `int` | `getExpandedTypeID(int nodeHandle)` Given a node handle, return an ID that represents the node's expanded name.
    `int` | `getExpandedTypeID(java.lang.String namespace, java.lang.String localName, int type)` Given an expanded name, return an ID.
    `int` | `getFirstAttribute(int nodeHandle)` Given a node handle, get the index of the node's first attribute.
    `int` | `getFirstChild(int nodeHandle)` Given a node handle, get the handle of the node's first child.
    `int` | `getFirstNamespaceNode(int nodeHandle, boolean inScope)` Given a node handle, get the index of the node's first child.
    `int` | `getLastChild(int nodeHandle)` Given a node handle, advance to its last child.
    `short` | `getLevel(int nodeHandle)` Get the depth level of this node in the tree (equals 1 for a parentless node).
    `org.xml.sax.ext.LexicalHandler` | `getLexicalHandler()` Return this DTM's lexical handler.
    `java.lang.String` | `getLocalName(int nodeHandle)` Given a node handle, return its DOM-style localname.
    `java.lang.String` | `getLocalNameFromExpandedNameID(int ExpandedNameID)` Given an expanded-name ID, return the local name part.
    `DTMStringPool` | `getLocalNameTable()` Get a reference pointer to the element name symbol table.
    `java.lang.String` | `getNamespaceFromExpandedNameID(int ExpandedNameID)` Given an expanded-name ID, return the namespace URI part.
    `java.lang.String` | `getNamespaceURI(int nodeHandle)` Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)
    `int` | `getNextAttribute(int nodeHandle)` Given a node handle, advance to the next attribute.
    `int` | `getNextDescendant(int subtreeRootHandle, int nodeHandle)` Given a node handle, advance to its next descendant.
    `int` | `getNextFollowing(int axisContextHandle, int nodeHandle)` Given a node handle, advance to the next node on the following axis.
    `int` | `getNextNamespaceNode(int baseHandle, int namespaceHandle, boolean inScope)` Given a namespace handle, advance to the next namespace.
    `int` | `getNextPreceding(int axisContextHandle, int nodeHandle)` Given a node handle, advance to the next node on the preceding axis.
    `int` | `getNextSibling(int nodeHandle)` Given a node handle, advance to its next sibling.
    `org.w3c.dom.Node` | `getNode(int nodeHandle)` Return an DOM node for the given node.
    `java.lang.String` | `getNodeName(int nodeHandle)` Given a node handle, return its DOM-style node name.
    `java.lang.String` | `getNodeNameX(int nodeHandle)` Given a node handle, return the XPath node name.
    `short` | `getNodeType(int nodeHandle)` Given a node handle, return its DOM-style node type.
    `java.lang.String` | `getNodeValue(int nodeHandle)` Given a node handle, return its node value.
    `DTMStringPool` | `getNsNameTable()` Get a reference pointer to the namespace URI symbol table.
    `int` | `getOwnerDocument(int nodeHandle)` Given a node handle, find the owning document node.
    `int` | `getParent(int nodeHandle)` Given a node handle, find its parent node.
    `java.lang.String` | `getPrefix(int nodeHandle)` Given a namespace handle, return the prefix that the namespace decl is mapping.
    `DTMStringPool` | `getPrefixNameTable()` Get a reference pointer to the prefix name symbol table.
    `int` | `getPreviousSibling(int nodeHandle)` Given a node handle, find its preceeding sibling.
    `javax.xml.transform.SourceLocator` | `getSourceLocatorFor(int node)` Source information is not handled yet, so return `null` here.
    `XMLString` | `getStringValue(int nodeHandle)` Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
    `char[]` | `getStringValueChunk(int nodeHandle, int chunkIndex, int[] startAndLen)` Get a character array chunk in the string-value of a node.
    `int` | `getStringValueChunkCount(int nodeHandle)` Get number of character array chunks in the string-value of a node.
    `DTMAxisIterator` | `getTypedAxisIterator(int axis, int type)` Get an iterator that can navigate over an XPath Axis, predicated by the extended type ID.
    `java.lang.String` | `getUnparsedEntityURI(java.lang.String name)` The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]).
    `boolean` | `hasChildNodes(int nodeHandle)` Given a node handle, test if it has child nodes.
    `void` | `ignorableWhitespace(char[] ch, int start, int length)`
    `boolean` | `isAttributeSpecified(int attributeHandle)` 5.
    `boolean` | `isCharacterElementContentWhitespace(int nodeHandle)` 2.
    `boolean` | `isDocumentAllDeclarationsProcessed(int documentHandle)` 10.
    `boolean` | `isNodeAfter(int nodeHandle1, int nodeHandle2)` Figure out whether nodeHandle2 should be considered as being later in the document than nodeHandle1, in Document Order as defined by the XPath model.
    `boolean` | `isSupported(java.lang.String feature, java.lang.String version)` Tests whether DTM DOM implementation implements a specific feature and that feature is supported by this node.
    `void` | `migrateTo(DTMManager manager)` Migrate a DTM built with an old DTMManager to a new DTMManager.
    `boolean` | `needsTwoThreads()`
    `void` | `processingInstruction(java.lang.String target, java.lang.String data)`
    `void` | `setDocumentBaseURI(java.lang.String baseURI)` Set the base URI of the document entity.
    `void` | `setDocumentLocator(org.xml.sax.Locator locator)`
    `void` | `setFeature(java.lang.String featureId, boolean state)` Set an implementation dependent feature.
    `void` | `setIncrementalSAXSource(IncrementalSAXSource source)` Bind a IncrementalSAXSource to this DTM.
    `void` | `setLocalNameTable(DTMStringPool poolRef)` Set a reference pointer to the element name symbol table.
    `void` | `setNsNameTable(DTMStringPool poolRef)` Set a reference pointer to the namespace URI symbol table.
    `void` | `setPrefixNameTable(DTMStringPool poolRef)` Set a reference pointer to the prefix name symbol table.
    `void` | `setProperty(java.lang.String property, java.lang.Object value)` For the moment all the run time properties are ignored by this class.
    `void` | `skippedEntity(java.lang.String name)`
    `void` | `startCDATA()`
    `void` | `startDocument()`
    `void` | `startDTD(java.lang.String name, java.lang.String publicId, java.lang.String systemId)`
    `void` | `startElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName, org.xml.sax.Attributes atts)`
    `void` | `startEntity(java.lang.String name)`
    `void` | `startPrefixMapping(java.lang.String prefix, java.lang.String uri)`
    `boolean` | `supportsPreStripping()` Return true if the xsl:strip-space or xsl:preserve-space was processed during construction of the DTM document.

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DTMDocumentImpl

          public DTMDocumentImpl(DTMManager mgr,
                                 int documentNumber,
                                 DTMWSFilter whiteSpaceFilter,
                                 XMLStringFactory xstringfactory)

      Construct a DTM.
      Parameters:
        `documentNumber` - the ID number assigned to this document. It will be shifted up into the high bits and returned as part of all node ID numbers, so those IDs indicate which document they came from as well as a location within the document. It is the DTMManager's responsibility to assign a unique number to each document.

  - ### Method Detail

    - #### setIncrementalSAXSource

          public void setIncrementalSAXSource(IncrementalSAXSource source)

      Bind a IncrementalSAXSource to this DTM. If we discover we need nodes that have not yet been built, we will ask this object to send us more events, and it will manage interactions with its data sources. Note that we do not actually build the IncrementalSAXSource, since we don't know what source it's reading from, what thread that source will run in, or when it will run.
      Parameters:
        `source` - The IncrementalSAXSource that we want to recieve events from on demand.

    - #### setFeature

          public void setFeature(java.lang.String featureId,
                                 boolean state)

      Set an implementation dependent feature.

      %REVIEW% Do we really expect to set features on DTMs?

      Specified by:
        `setFeature` in interface `DTM`
      Parameters:
        `featureId` - A feature URL.
        `state` - true if this feature should be on, false otherwise.

    - #### setLocalNameTable

          public void setLocalNameTable(DTMStringPool poolRef)

      Set a reference pointer to the element name symbol table. %REVIEW% Should this really be Public? Changing it while DTM is in use would be a disaster.
      Parameters:
        `poolRef` - DTMStringPool reference to an instance of table.

    - #### getLocalNameTable

          public DTMStringPool getLocalNameTable()

      Get a reference pointer to the element name symbol table.
      Returns:
        DTMStringPool reference to an instance of table.

    - #### setNsNameTable

          public void setNsNameTable(DTMStringPool poolRef)

      Set a reference pointer to the namespace URI symbol table. %REVIEW% Should this really be Public? Changing it while DTM is in use would be a disaster.
      Parameters:
        `poolRef` - DTMStringPool reference to an instance of table.

    - #### getNsNameTable

          public DTMStringPool getNsNameTable()

      Get a reference pointer to the namespace URI symbol table.
      Returns:
        DTMStringPool reference to an instance of table.

    - #### setPrefixNameTable

          public void setPrefixNameTable(DTMStringPool poolRef)

      Set a reference pointer to the prefix name symbol table. %REVIEW% Should this really be Public? Changing it while DTM is in use would be a disaster.
      Parameters:
        `poolRef` - DTMStringPool reference to an instance of table.

    - #### getPrefixNameTable

          public DTMStringPool getPrefixNameTable()

      Get a reference pointer to the prefix name symbol table.
      Returns:
        DTMStringPool reference to an instance of table.

    - #### getContentHandler

          public org.xml.sax.ContentHandler getContentHandler()

      getContentHandler returns "our SAX builder" -- the thing that someone else should send SAX events to in order to extend this DTM model.
      Specified by:
        `getContentHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX events, "this" if the DTM object has a built-in SAX ContentHandler, the IncrementalSAXSource if we're bound to one and should receive the SAX stream via it for incremental build purposes...

    - #### getLexicalHandler

          public org.xml.sax.ext.LexicalHandler getLexicalHandler()

      Return this DTM's lexical handler. %REVIEW% Should this return null if constrution already done/begun?
      Specified by:
        `getLexicalHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to lexical SAX events, "this" if the DTM object has a built-in SAX ContentHandler, the IncrementalSAXSource if we're bound to one and should receive the SAX stream via it for incremental build purposes...

    - #### getEntityResolver

          public org.xml.sax.EntityResolver getEntityResolver()

      Return this DTM's EntityResolver.
      Specified by:
        `getEntityResolver` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX entity ref events.

    - #### getDTDHandler

          public org.xml.sax.DTDHandler getDTDHandler()

      Return this DTM's DTDHandler.
      Specified by:
        `getDTDHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX dtd events.

    - #### getErrorHandler

          public org.xml.sax.ErrorHandler getErrorHandler()

      Return this DTM's ErrorHandler.
      Specified by:
        `getErrorHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX error events.

    - #### getDeclHandler

          public org.xml.sax.ext.DeclHandler getDeclHandler()

      Return this DTM's DeclHandler.
      Specified by:
        `getDeclHandler` in interface `DTM`
      Returns:
        null if this model doesn't respond to SAX Decl events.

    - #### needsTwoThreads

          public boolean needsTwoThreads()

      Specified by:
        `needsTwoThreads` in interface `DTM`
      Returns:
        true iff we're building this model incrementally (eg we're partnered with a IncrementalSAXSource) and thus require that the transformation and the parse run simultaneously. Guidance to the DTMManager.

    - #### characters

          public void characters(char[] ch,
                                 int start,
                                 int length)
                          throws org.xml.sax.SAXException

      Specified by:
        `characters` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endDocument

          public void endDocument()
                           throws org.xml.sax.SAXException

      Specified by:
        `endDocument` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endElement

          public void endElement(java.lang.String namespaceURI,
                                 java.lang.String localName,
                                 java.lang.String qName)
                          throws org.xml.sax.SAXException

      Specified by:
        `endElement` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endPrefixMapping

          public void endPrefixMapping(java.lang.String prefix)
                                throws org.xml.sax.SAXException

      Specified by:
        `endPrefixMapping` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### ignorableWhitespace

          public void ignorableWhitespace(char[] ch,
                                          int start,
                                          int length)
                                   throws org.xml.sax.SAXException

      Specified by:
        `ignorableWhitespace` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### processingInstruction

          public void processingInstruction(java.lang.String target,
                                            java.lang.String data)
                                     throws org.xml.sax.SAXException

      Specified by:
        `processingInstruction` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### setDocumentLocator

          public void setDocumentLocator(org.xml.sax.Locator locator)

      Specified by:
        `setDocumentLocator` in interface `org.xml.sax.ContentHandler`

    - #### skippedEntity

          public void skippedEntity(java.lang.String name)
                             throws org.xml.sax.SAXException

      Specified by:
        `skippedEntity` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startDocument

          public void startDocument()
                             throws org.xml.sax.SAXException

      Specified by:
        `startDocument` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startElement

          public void startElement(java.lang.String namespaceURI,
                                   java.lang.String localName,
                                   java.lang.String qName,
                                   org.xml.sax.Attributes atts)
                            throws org.xml.sax.SAXException

      Specified by:
        `startElement` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startPrefixMapping

          public void startPrefixMapping(java.lang.String prefix,
                                         java.lang.String uri)
                                  throws org.xml.sax.SAXException

      Specified by:
        `startPrefixMapping` in interface `org.xml.sax.ContentHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### comment

          public void comment(char[] ch,
                              int start,
                              int length)
                       throws org.xml.sax.SAXException

      Specified by:
        `comment` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endCDATA

          public void endCDATA()
                        throws org.xml.sax.SAXException

      Specified by:
        `endCDATA` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endDTD

          public void endDTD()
                      throws org.xml.sax.SAXException

      Specified by:
        `endDTD` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### endEntity

          public void endEntity(java.lang.String name)
                         throws org.xml.sax.SAXException

      Specified by:
        `endEntity` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startCDATA

          public void startCDATA()
                          throws org.xml.sax.SAXException

      Specified by:
        `startCDATA` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startDTD

          public void startDTD(java.lang.String name,
                               java.lang.String publicId,
                               java.lang.String systemId)
                        throws org.xml.sax.SAXException

      Specified by:
        `startDTD` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### startEntity

          public void startEntity(java.lang.String name)
                           throws org.xml.sax.SAXException

      Specified by:
        `startEntity` in interface `org.xml.sax.ext.LexicalHandler`
      Throws:
        `org.xml.sax.SAXException`

    - #### hasChildNodes

          public boolean hasChildNodes(int nodeHandle)

      Given a node handle, test if it has child nodes.

      %REVIEW% This is obviously useful at the DOM layer, where it would permit testing this without having to create a proxy node. It's less useful in the DTM API, where (dtm.getFirstChild(nodeHandle)!=DTM.NULL) is just as fast and almost as self-evident. But it's a convenience, and eases porting of DOM code to DTM.

      Specified by:
        `hasChildNodes` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int true if the given node has child nodes.

    - #### getFirstChild

          public int getFirstChild(int nodeHandle)

      Given a node handle, get the handle of the node's first child. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Specified by:
        `getFirstChild` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int DTM node-number of first child, or DTM.NULL to indicate none exists.

    - #### getLastChild

          public int getLastChild(int nodeHandle)

      Given a node handle, advance to its last child. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Specified by:
        `getLastChild` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int Node-number of last child, or DTM.NULL to indicate none exists.

    - #### getAttributeNode

          public int getAttributeNode(int nodeHandle,
                                      java.lang.String namespaceURI,
                                      java.lang.String name)

      Retrieves an attribute node by by qualified name and namespace URI.
      Specified by:
        `getAttributeNode` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node upon which to look up this attribute.
        `namespaceURI` - The namespace URI of the attribute to retrieve, or null.
        `name` - The local name of the attribute to retrieve.
      Returns:
        The attribute node handle with the specified name ( `nodeName`) or `DTM.NULL` if there is no such attribute.

    - #### getFirstAttribute

          public int getFirstAttribute(int nodeHandle)

      Given a node handle, get the index of the node's first attribute.
      Specified by:
        `getFirstAttribute` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the Element node.
      Returns:
        Handle of first attribute, or DTM.NULL to indicate none exists.

    - #### getFirstNamespaceNode

          public int getFirstNamespaceNode(int nodeHandle,
                                           boolean inScope)

      Given a node handle, get the index of the node's first child. If not yet resolved, waits for more nodes to be added to the document and tries again
      Specified by:
        `getFirstNamespaceNode` in interface `DTM`
      Parameters:
        `nodeHandle` - handle to node, which should probably be an element node, but need not be.
        `inScope` - true if all namespaces in scope should be returned, false if only the namespace declarations should be returned.
      Returns:
        handle of first namespace, or DTM.NULL to indicate none exists.

    - #### getNextSibling

          public int getNextSibling(int nodeHandle)

      Given a node handle, advance to its next sibling. %TBD% This currently uses the DTM-internal definition of sibling; eg, the last attr's next sib is the first child. In the old DTM, the DOM proxy layer provided the additional logic for the public view. If we're rewriting for XPath emulation, that test must be done here. %TBD% CODE INTERACTION WITH INCREMENTAL PARSE - If not yet resolved, should wait for more nodes to be added to the document and tries again.
      Specified by:
        `getNextSibling` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int Node-number of next sibling, or DTM.NULL to indicate none exists.

    - #### getPreviousSibling

          public int getPreviousSibling(int nodeHandle)

      Given a node handle, find its preceeding sibling. WARNING: DTM is asymmetric; this operation is resolved by search, and is relatively expensive.
      Specified by:
        `getPreviousSibling` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node-number of the previous sib, or DTM.NULL to indicate none exists.

    - #### getNextAttribute

          public int getNextAttribute(int nodeHandle)

      Given a node handle, advance to the next attribute. If an element, we advance to its first attribute; if an attr, we advance to the next attr on the same node.
      Specified by:
        `getNextAttribute` in interface `DTM`
      Parameters:
        `nodeHandle` - int Handle of the node.
      Returns:
        int DTM node-number of the resolved attr, or DTM.NULL to indicate none exists.

    - #### getNextNamespaceNode

          public int getNextNamespaceNode(int baseHandle,
                                          int namespaceHandle,
                                          boolean inScope)

      Given a namespace handle, advance to the next namespace. %TBD% THIS METHOD DOES NOT MATCH THE CURRENT SIGNATURE IN THE DTM INTERFACE. FIX IT, OR JUSTIFY CHANGING THE DTM API.
      Specified by:
        `getNextNamespaceNode` in interface `DTM`
      Parameters:
        `namespaceHandle` - handle to node which must be of type NAMESPACE_NODE.
        `baseHandle` - handle to original node from where the first child was relative to (needed to return nodes in document order).
      Returns:
        handle of next namespace, or DTM.NULL to indicate none exists.

    - #### getNextDescendant

          public int getNextDescendant(int subtreeRootHandle,
                                       int nodeHandle)

      Given a node handle, advance to its next descendant. If not yet resolved, waits for more nodes to be added to the document and tries again.
      Parameters:
        `subtreeRootHandle` -
        `nodeHandle` - int Handle of the node.
      Returns:
        handle of next descendant, or DTM.NULL to indicate none exists.

    - #### getNextFollowing

          public int getNextFollowing(int axisContextHandle,
                                      int nodeHandle)

      Given a node handle, advance to the next node on the following axis.
      Parameters:
        `axisContextHandle` - the start of the axis that is being traversed.
        `nodeHandle` -
      Returns:
        handle of next sibling, or DTM.NULL to indicate none exists.

    - #### getNextPreceding

          public int getNextPreceding(int axisContextHandle,
                                      int nodeHandle)

      Given a node handle, advance to the next node on the preceding axis.
      Parameters:
        `axisContextHandle` - the start of the axis that is being traversed.
        `nodeHandle` - the id of the node.
      Returns:
        int Node-number of preceding sibling, or DTM.NULL to indicate none exists.

    - #### getParent

          public int getParent(int nodeHandle)

      Given a node handle, find its parent node.
      Specified by:
        `getParent` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node-number of parent, or DTM.NULL to indicate none exists.

    - #### getDocumentRoot

          public int getDocumentRoot()

      Returns the root element of the document.
      Returns:
        nodeHandle to the Document Root.

    - #### getDocument

          public int getDocument()

      Given a node handle, find the owning document node.
      Specified by:
        `getDocument` in interface `DTM`
      Returns:
        int Node handle of document, which should always be valid.

    - #### getOwnerDocument

          public int getOwnerDocument(int nodeHandle)

      Given a node handle, find the owning document node. This has the exact same semantics as the DOM Document method of the same name, in that if the nodeHandle is a document node, it will return NULL.

      %REVIEW% Since this is DOM-specific, it may belong at the DOM binding layer. Included here as a convenience function and to aid porting of DOM code to DTM.

      Specified by:
        `getOwnerDocument` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node handle of owning document, or NULL if the nodeHandle is a document.
      See Also:
        `DTM.getDocumentRoot(int nodeHandle)`

    - #### getDocumentRoot

          public int getDocumentRoot(int nodeHandle)

      Given a node handle, find the owning document node. This has the DTM semantics; a Document node is its own owner.

      %REVIEW% Since this is DOM-specific, it may belong at the DOM binding layer. Included here as a convenience function and to aid porting of DOM code to DTM.

      Specified by:
        `getDocumentRoot` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        int Node handle of owning document, or NULL if the nodeHandle is a document.
      See Also:
        `DTM.getOwnerDocument(int nodeHandle)`

    - #### getStringValue

          public XMLString getStringValue(int nodeHandle)

      Get the string-value of a node as a String object (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value).
      Specified by:
        `getStringValue` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A string object that represents the string-value of the given node.

    - #### getStringValueChunkCount

          public int getStringValueChunkCount(int nodeHandle)

      Get number of character array chunks in the string-value of a node. (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Note that a single text node may have multiple text chunks. EXPLANATION: This method is an artifact of the fact that the underlying m_chars object may not store characters in a single contiguous array -- for example,the current FastStringBuffer may split a single node's text across multiple allocation units. This call tells us how many separate accesses will be required to retrieve the entire content. PLEASE NOTE that this may not be the same as the number of SAX characters() events that caused the text node to be built in the first place, since m_chars buffering may be on different boundaries than the parser's buffers.
      Specified by:
        `getStringValueChunkCount` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        number of character array chunks in the string-value of a node.

    - #### getStringValueChunk

          public char[] getStringValueChunk(int nodeHandle,
                                            int chunkIndex,
                                            int[] startAndLen)

      Get a character array chunk in the string-value of a node. (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Note that a single text node may have multiple text chunks. EXPLANATION: This method is an artifact of the fact that the underlying m_chars object may not store characters in a single contiguous array -- for example,the current FastStringBuffer may split a single node's text across multiple allocation units. This call retrieves a single contiguous portion of the text -- as much as m-chars was able to store in a single allocation unit. PLEASE NOTE that this may not be the same granularityas the SAX characters() events that caused the text node to be built in the first place, since m_chars buffering may be on different boundaries than the parser's buffers.
      Specified by:
        `getStringValueChunk` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `chunkIndex` - Which chunk to get.
        `startAndLen` - An array of 2 where the start position and length of the chunk will be returned.
      Returns:
        The character array reference where the chunk occurs.

    - #### getExpandedTypeID

          public int getExpandedTypeID(int nodeHandle)

      Given a node handle, return an ID that represents the node's expanded name.
      Specified by:
        `getExpandedTypeID` in interface `DTM`
      Parameters:
        `nodeHandle` - The handle to the node in question.
      Returns:
        the expanded-name id of the node.

    - #### getExpandedTypeID

          public int getExpandedTypeID(java.lang.String namespace,
                                       java.lang.String localName,
                                       int type)

      Given an expanded name, return an ID. If the expanded-name does not exist in the internal tables, the entry will be created, and the ID will be returned. Any additional nodes that are created that have this expanded name will use this ID.
      Specified by:
        `getExpandedTypeID` in interface `DTM`
      Returns:
        the expanded-name id of the node.

    - #### getLocalNameFromExpandedNameID

          public java.lang.String getLocalNameFromExpandedNameID(int ExpandedNameID)

      Given an expanded-name ID, return the local name part.
      Specified by:
        `getLocalNameFromExpandedNameID` in interface `DTM`
      Parameters:
        `ExpandedNameID` - an ID that represents an expanded-name.
      Returns:
        String Local name of this node.

    - #### getNamespaceFromExpandedNameID

          public java.lang.String getNamespaceFromExpandedNameID(int ExpandedNameID)

      Given an expanded-name ID, return the namespace URI part.
      Specified by:
        `getNamespaceFromExpandedNameID` in interface `DTM`
      Parameters:
        `ExpandedNameID` - an ID that represents an expanded-name.
      Returns:
        String URI value of this node's namespace, or null if no namespace was resolved.

    - #### getNodeName

          public java.lang.String getNodeName(int nodeHandle)

      Given a node handle, return its DOM-style node name. This will include names such as #text or #document.
      Specified by:
        `getNodeName` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Name of this node, which may be an empty string. %REVIEW% Document when empty string is possible...

    - #### getNodeNameX

          public java.lang.String getNodeNameX(int nodeHandle)

      Given a node handle, return the XPath node name. This should be the name as described by the XPath data model, NOT the DOM-style name.
      Specified by:
        `getNodeNameX` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Name of this node.

    - #### getLocalName

          public java.lang.String getLocalName(int nodeHandle)

      Given a node handle, return its DOM-style localname. (As defined in Namespaces, this is the portion of the name after any colon character) %REVIEW% What's the local name of something other than Element/Attr? Should this be DOM-style (undefined unless namespaced), or other?
      Specified by:
        `getLocalName` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String Local name of this node.

    - #### getPrefix

          public java.lang.String getPrefix(int nodeHandle)

      Given a namespace handle, return the prefix that the namespace decl is mapping. Given a node handle, return the prefix used to map to the namespace.

      %REVIEW% Are you sure you want "" for no prefix?

      %REVIEW% Should this be DOM-style (undefined unless namespaced), or other?
      Specified by:
        `getPrefix` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String prefix of this node's name, or "" if no explicit namespace prefix was given.

    - #### getNamespaceURI

          public java.lang.String getNamespaceURI(int nodeHandle)

      Given a node handle, return its DOM-style namespace URI (As defined in Namespaces, this is the declared URI which this node's prefix -- or default in lieu thereof -- was mapped to.)
      Specified by:
        `getNamespaceURI` in interface `DTM`
      Parameters:
        `nodeHandle` - the id of the node.
      Returns:
        String URI value of this node's namespace, or null if no namespace was resolved.

    - #### getNodeValue

          public java.lang.String getNodeValue(int nodeHandle)

      Given a node handle, return its node value. This is mostly as defined by the DOM, but may ignore some conveniences.

      Specified by:
        `getNodeValue` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        String Value of this node, or null if not meaningful for this node type.

    - #### getNodeType

          public short getNodeType(int nodeHandle)

      Given a node handle, return its DOM-style node type.

      %REVIEW% Generally, returning short is false economy. Return int?

      Specified by:
        `getNodeType` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        int Node type, as per the DOM's Node._NODE constants.

    - #### getLevel

          public short getLevel(int nodeHandle)

      Get the depth level of this node in the tree (equals 1 for a parentless node).
      Specified by:
        `getLevel` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id.
      Returns:
        the number of ancestors, plus one
      Usage:
        **For internal use only**

    - #### isSupported

          public boolean isSupported(java.lang.String feature,
                                     java.lang.String version)

      Tests whether DTM DOM implementation implements a specific feature and that feature is supported by this node.
      Specified by:
        `isSupported` in interface `DTM`
      Parameters:
        `feature` - The name of the feature to test.
        `version` - This is the version number of the feature to test. If the version is not specified, supporting any version of the feature will cause the method to return `true`.
      Returns:
        Returns `true` if the specified feature is supported on this node, `false` otherwise.

    - #### getDocumentBaseURI

          public java.lang.String getDocumentBaseURI()

      Return the base URI of the document entity. If it is not known (because the document was parsed from a socket connection or from standard input, for example), the value of this property is unknown.
      Specified by:
        `getDocumentBaseURI` in interface `DTM`
      Returns:
        the document base URI String object or null if unknown.

    - #### setDocumentBaseURI

          public void setDocumentBaseURI(java.lang.String baseURI)

      Set the base URI of the document entity.
      Specified by:
        `setDocumentBaseURI` in interface `DTM`
      Parameters:
        `baseURI` - the document base URI String object or null if unknown.

    - #### getDocumentSystemIdentifier

          public java.lang.String getDocumentSystemIdentifier(int nodeHandle)

      Return the system identifier of the document entity. If it is not known, the value of this property is unknown.
      Specified by:
        `getDocumentSystemIdentifier` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the system identifier String object or null if unknown.

    - #### getDocumentEncoding

          public java.lang.String getDocumentEncoding(int nodeHandle)

      Return the name of the character encoding scheme in which the document entity is expressed.
      Specified by:
        `getDocumentEncoding` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the document encoding String object.

    - #### getDocumentStandalone

          public java.lang.String getDocumentStandalone(int nodeHandle)

      Return an indication of the standalone status of the document, either "yes" or "no". This property is derived from the optional standalone document declaration in the XML declaration at the beginning of the document entity, and has no value if there is no standalone document declaration.
      Specified by:
        `getDocumentStandalone` in interface `DTM`
      Parameters:
        `nodeHandle` - The node id, which can be any valid node handle.
      Returns:
        the document standalone String object, either "yes", "no", or null.

    - #### getDocumentVersion

          public java.lang.String getDocumentVersion(int documentHandle)

      Return a string representing the XML version of the document. This property is derived from the XML declaration optionally present at the beginning of the document entity, and has no value if there is no XML declaration.
      Specified by:
        `getDocumentVersion` in interface `DTM`
      Parameters:
        `documentHandle` - the document handle
      Returns:
        the document version String object

    - #### getDocumentAllDeclarationsProcessed

          public boolean getDocumentAllDeclarationsProcessed()

      Return an indication of whether the processor has read the complete DTD. Its value is a boolean. If it is false, then certain properties (indicated in their descriptions below) may be unknown. If it is true, those properties are never unknown.
      Specified by:
        `getDocumentAllDeclarationsProcessed` in interface `DTM`
      Returns:
        `true` if all declarations were processed {}; `false` otherwise.

    - #### getDocumentTypeDeclarationSystemIdentifier

          public java.lang.String getDocumentTypeDeclarationSystemIdentifier()

      A document type declaration information item has the following properties: 1. [system identifier] The system identifier of the external subset, if it exists. Otherwise this property has no value.
      Specified by:
        `getDocumentTypeDeclarationSystemIdentifier` in interface `DTM`
      Returns:
        the system identifier String object, or null if there is none.

    - #### getDocumentTypeDeclarationPublicIdentifier

          public java.lang.String getDocumentTypeDeclarationPublicIdentifier()

      Return the public identifier of the external subset, normalized as described in 4.2.2 External Entities [XML]. If there is no external subset or if it has no public identifier, this property has no value.
      Specified by:
        `getDocumentTypeDeclarationPublicIdentifier` in interface `DTM`
      Returns:
        the public identifier String object, or null if there is none.

    - #### getElementById

          public int getElementById(java.lang.String elementId)

      Returns the `Element` whose `ID` is given by `elementId`. If no such element exists, returns `DTM.NULL`. Behavior is not defined if more than one element has this `ID`. Attributes (including those with the name "ID") are not of type ID unless so defined by DTD/Schema information available to the DTM implementation. Implementations that do not know whether attributes are of type ID or not are expected to return `DTM.NULL`.

      %REVIEW% Presumably IDs are still scoped to a single document, and this operation searches only within a single document, right? Wouldn't want collisions between DTMs in the same process.

      Specified by:
        `getElementById` in interface `DTM`
      Parameters:
        `elementId` - The unique `id` value for an element.
      Returns:
        The handle of the matching element.

    - #### getUnparsedEntityURI

          public java.lang.String getUnparsedEntityURI(java.lang.String name)

      The getUnparsedEntityURI function returns the URI of the unparsed entity with the specified name in the same document as the context node (see [3.3 Unparsed Entities]). It returns the empty string if there is no such entity.

      XML processors may choose to use the System Identifier (if one is provided) to resolve the entity, rather than the URI in the Public Identifier. The details are dependent on the processor, and we would have to support some form of plug-in resolver to handle this properly. Currently, we simply return the System Identifier if present, and hope that it a usable URI or that our caller can map it to one. TODO: Resolve Public Identifiers... or consider changing function name.

      If we find a relative URI reference, XML expects it to be resolved in terms of the base URI of the document. The DOM doesn't do that for us, and it isn't entirely clear whether that should be done here; currently that's pushed up to a higher level of our application. (Note that DOM Level 1 didn't store the document's base URI.) TODO: Consider resolving Relative URIs.

      (The DOM's statement that "An XML processor may choose to completely expand entities before the structure model is passed to the DOM" refers only to parsed entities, not unparsed, and hence doesn't affect this function.)

      Specified by:
        `getUnparsedEntityURI` in interface `DTM`
      Parameters:
        `name` - A string containing the Entity Name of the unparsed entity.
      Returns:
        String containing the URI of the Unparsed Entity, or an empty string if no such entity exists.

    - #### supportsPreStripping

          public boolean supportsPreStripping()

      Return true if the xsl:strip-space or xsl:preserve-space was processed during construction of the DTM document.

      %REVEIW% Presumes a 1:1 mapping from DTM to Document, since we aren't saying which Document to query...?

      Specified by:
        `supportsPreStripping` in interface `DTM`

    - #### isNodeAfter

          public boolean isNodeAfter(int nodeHandle1,
                                     int nodeHandle2)

      Figure out whether nodeHandle2 should be considered as being later in the document than nodeHandle1, in Document Order as defined by the XPath model. This may not agree with the ordering defined by other XML applications.

      There are some cases where ordering isn't defined, and neither are the results of this function -- though we'll generally return true. TODO: Make sure this does the right thing with attribute nodes!!!

      Specified by:
        `isNodeAfter` in interface `DTM`
      Parameters:
        `nodeHandle1` - DOM Node to perform position comparison on.
        `nodeHandle2` - DOM Node to perform position comparison on .
      Returns:
        false if node2 comes before node1, otherwise return true. You can think of this as `(node1.documentOrderPosition <= node2.documentOrderPosition)`.

    - #### isCharacterElementContentWhitespace

          public boolean isCharacterElementContentWhitespace(int nodeHandle)

      2. [element content whitespace] A boolean indicating whether the character is white space appearing within element content (see [XML], 2.10 "White Space Handling"). Note that validating XML processors are required by XML 1.0 to provide this information. If there is no declaration for the containing element, this property has no value for white space characters. If no declaration has been read, but the [all declarations processed] property of the document information item is false (so there may be an unread declaration), then the value of this property is unknown for white space characters. It is always false for characters that are not white space.
      Specified by:
        `isCharacterElementContentWhitespace` in interface `DTM`
      Parameters:
        `nodeHandle` - the node ID.
      Returns:
        `true` if the character data is whitespace; `false` otherwise.

    - #### isDocumentAllDeclarationsProcessed

          public boolean isDocumentAllDeclarationsProcessed(int documentHandle)

      10. [all declarations processed] This property is not strictly speaking part of the infoset of the document. Rather it is an indication of whether the processor has read the complete DTD. Its value is a boolean. If it is false, then certain properties (indicated in their descriptions below) may be unknown. If it is true, those properties are never unknown.
      Specified by:
        `isDocumentAllDeclarationsProcessed` in interface `DTM`
      Parameters:
        `documentHandle` - A node handle that must identify a document.
      Returns:
        `true` if all declarations were processed; `false` otherwise.

    - #### isAttributeSpecified

          public boolean isAttributeSpecified(int attributeHandle)

      5. [specified] A flag indicating whether this attribute was actually specified in the start-tag of its element, or was defaulted from the DTD.
      Specified by:
        `isAttributeSpecified` in interface `DTM`
      Parameters:
        `attributeHandle` - the attribute handle
      Returns:
        `true` if the attribute was specified; `false` if it was defaulted.

    - #### dispatchCharactersEvents

          public void dispatchCharactersEvents(int nodeHandle,
                                               org.xml.sax.ContentHandler ch,
                                               boolean normalize)
                                        throws org.xml.sax.SAXException

      Directly call the characters method on the passed ContentHandler for the string-value of the given node (see http://www.w3.org/TR/xpath#data-model for the definition of a node's string-value). Multiple calls to the ContentHandler's characters methods may well occur for a single call to this method.
      Specified by:
        `dispatchCharactersEvents` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
        `normalize` - true if the content should be normalized according to the rules for the XPath normalize-space function.
      Throws:
        `org.xml.sax.SAXException`

    - #### dispatchToEvents

          public void dispatchToEvents(int nodeHandle,
                                       org.xml.sax.ContentHandler ch)
                                throws org.xml.sax.SAXException

      Directly create SAX parser events from a subtree.
      Specified by:
        `dispatchToEvents` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
        `ch` - A non-null reference to a ContentHandler.
      Throws:
        `org.xml.sax.SAXException`

    - #### getNode

          public org.w3c.dom.Node getNode(int nodeHandle)

      Return an DOM node for the given node.
      Specified by:
        `getNode` in interface `DTM`
      Parameters:
        `nodeHandle` - The node ID.
      Returns:
        A node representation of the DTM node.

    - #### appendChild

          public void appendChild(int newChild,
                                  boolean clone,
                                  boolean cloneDepth)

      Append a child to the end of the child list of the current node. Please note that the node is always cloned if it is owned by another document.

      %REVIEW% "End of the document" needs to be defined more clearly. Does it become the last child of the Document? Of the root element?

      Specified by:
        `appendChild` in interface `DTM`
      Parameters:
        `newChild` - Must be a valid new node handle.
        `clone` - true if the child should be cloned into the document.
        `cloneDepth` - if the clone argument is true, specifies that the clone should include all it's children.

    - #### appendTextChild

          public void appendTextChild(java.lang.String str)

      Append a text node child that will be constructed from a string, to the end of the document.

      %REVIEW% "End of the document" needs to be defined more clearly. Does it become the last child of the Document? Of the root element?

      Specified by:
        `appendTextChild` in interface `DTM`
      Parameters:
        `str` - Non-null reference to a string.

    - #### getAxisTraverser

          public DTMAxisTraverser getAxisTraverser(int axis)

      This returns a stateless "traverser", that can navigate over an XPath axis, though not in document order.
      Specified by:
        `getAxisTraverser` in interface `DTM`
      Parameters:
        `axis` - One of Axes.ANCESTORORSELF, etc.
      Returns:
        A DTMAxisIterator, or null if the given axis isn't supported.

    - #### getAxisIterator

          public DTMAxisIterator getAxisIterator(int axis)

      This is a shortcut to the iterators that implement the supported XPath axes (only namespace::) is not supported. Returns a bare-bones iterator that must be initialized with a start node (using iterator.setStartNode()).
      Specified by:
        `getAxisIterator` in interface `DTM`
      Parameters:
        `axis` - One of Axes.ANCESTORORSELF, etc.
      Returns:
        A DTMAxisIterator, or null if the given axis isn't supported.

    - #### getTypedAxisIterator

          public DTMAxisIterator getTypedAxisIterator(int axis,
                                                      int type)

      Get an iterator that can navigate over an XPath Axis, predicated by the extended type ID.
      Specified by:
        `getTypedAxisIterator` in interface `DTM`
      Parameters:
        `axis` -
        `type` - An extended type ID.
      Returns:
        A DTMAxisIterator, or null if the given axis isn't supported.

    - #### setProperty

          public void setProperty(java.lang.String property,
                                  java.lang.Object value)

      For the moment all the run time properties are ignored by this class.
      Specified by:
        `setProperty` in interface `DTM`
      Parameters:
        `property` - a `String` value
        `value` - an `Object` value

    - #### getSourceLocatorFor

          public javax.xml.transform.SourceLocator getSourceLocatorFor(int node)

      Source information is not handled yet, so return `null` here.
      Specified by:
        `getSourceLocatorFor` in interface `DTM`
      Parameters:
        `node` - an `int` value
      Returns:
        null

    - #### documentRegistration

          public void documentRegistration()

      A dummy routine to satisify the abstract interface. If the DTM implememtation that extends the default base requires notification of registration, they can override this method.
      Specified by:
        `documentRegistration` in interface `DTM`

    - #### documentRelease

          public void documentRelease()

      A dummy routine to satisify the abstract interface. If the DTM implememtation that extends the default base requires notification when the document is being released, they can override this method
      Specified by:
        `documentRelease` in interface `DTM`

    - #### migrateTo

          public void migrateTo(DTMManager manager)

      Migrate a DTM built with an old DTMManager to a new DTMManager. After the migration, the new DTMManager will treat the DTM as one that is built by itself. This is used to support DTM sharing between multiple transformations.
      Specified by:
        `migrateTo` in interface `DTM`
      Parameters:
        `manager` - the DTMManager

Copyright © 2023 Apache XML Project. All Rights Reserved.